from .codes import ERROR_INTERNAL_ERROR as ERROR_INTERNAL_ERROR, ERROR_INVALID_PARAMS as ERROR_INVALID_PARAMS, ERROR_METHOD_NOT_FOUND as ERROR_METHOD_NOT_FOUND
from .sentinels import NODATA as NODATA
from oslash.either import Either
from typing import Any, NamedTuple

class SuccessResult(NamedTuple):
    result: Any = ...

class ErrorResult(NamedTuple):
    code: int
    message: str
    data: Any = ...
Result = Either[SuccessResult, ErrorResult]

def MethodNotFoundResult(data: Any) -> ErrorResult: ...
def InternalErrorResult(data: Any) -> ErrorResult: ...
def InvalidParamsResult(data: Any=...) -> ErrorResult: ...
def Success(*args: Any, **kwargs: Any) -> Either[ErrorResult, SuccessResult]: ...
def Error(*args: Any, **kwargs: Any) -> Either[ErrorResult, SuccessResult]: ...
def InvalidParams(*args: Any, **kwargs: Any) -> Either[ErrorResult, SuccessResult]: ...
