from typing import Any, Callable, ClassVar, Dict, Union

import ipaddress
import pathlib
import pydantic.utils
import typing
Any: typing._SpecialForm
Callable: typing._VariadicGenericAlias
Dict: typing._GenericAlias
ENCODERS_BY_TYPE: dict
Type: typing._GenericAlias
Union: typing._SpecialForm
custom_pydantic_encoder: cython_function_or_method
decimal_encoder: cython_function_or_method
isoformat: cython_function_or_method
pydantic_encoder: cython_function_or_method
timedelta_isoformat: cython_function_or_method

class Color(pydantic.utils.Representation):
    _original: ClassVar[member_descriptor] = ...
    _rgba: ClassVar[member_descriptor] = ...
    __slots__: ClassVar[tuple] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def _alpha_float(self, *args, **kwargs) -> Any: ...
    def as_hex(self, *args, **kwargs) -> Any: ...
    def as_hsl(self, *args, **kwargs) -> Any: ...
    def as_hsl_tuple(self, *args, **kwargs) -> Any: ...
    def as_named(self, *args, **kwargs) -> Any: ...
    def as_rgb(self, *args, **kwargs) -> Any: ...
    def as_rgb_tuple(self, *args, **kwargs) -> Any: ...
    def original(self, *args, **kwargs) -> Any: ...
    @classmethod
    def __get_validators__(self, *args, **kwargs) -> Any: ...
    @classmethod
    def __modify_schema__(self, *args, **kwargs) -> Any: ...
    def __repr_args__(self, *args, **kwargs) -> Any: ...

class Decimal:
    imag: ClassVar[getset_descriptor] = ...
    real: ClassVar[getset_descriptor] = ...
    @classmethod
    def __init__(self, *args, **kwargs) -> None: ...
    def adjusted(self, *args, **kwargs) -> Any: ...
    def as_integer_ratio(self, *args, **kwargs) -> Any: ...
    def as_tuple(self, *args, **kwargs) -> Any: ...
    def canonical(self, *args, **kwargs) -> Any: ...
    def compare(self, *args, **kwargs) -> Any: ...
    def compare_signal(self, *args, **kwargs) -> Any: ...
    def compare_total(self, *args, **kwargs) -> Any: ...
    def compare_total_mag(y) -> Any: ...
    def conjugate(self, *args, **kwargs) -> Any: ...
    def copy_abs(self, *args, **kwargs) -> Any: ...
    def copy_negate(self, *args, **kwargs) -> Any: ...
    def copy_sign(self, *args, **kwargs) -> Any: ...
    def exp(self, *args, **kwargs) -> Any: ...
    def fma(self, *args, **kwargs) -> Any: ...
    @classmethod
    def from_float(self, *args, **kwargs) -> Any: ...
    def is_canonical(self, *args, **kwargs) -> Any: ...
    def is_finite(self, *args, **kwargs) -> Any: ...
    def is_infinite(self, *args, **kwargs) -> Any: ...
    def is_nan(self, *args, **kwargs) -> Any: ...
    def is_normal(self, *args, **kwargs) -> Any: ...
    def is_qnan(self, *args, **kwargs) -> Any: ...
    def is_signed(self, *args, **kwargs) -> Any: ...
    def is_snan(self, *args, **kwargs) -> Any: ...
    def is_subnormal(self, *args, **kwargs) -> Any: ...
    def is_zero(self, *args, **kwargs) -> Any: ...
    def ln(self, *args, **kwargs) -> Any: ...
    def log10(self, *args, **kwargs) -> Any: ...
    def logb(self, *args, **kwargs) -> Any: ...
    def logical_and(self, *args, **kwargs) -> Any: ...
    def logical_invert(self, *args, **kwargs) -> Any: ...
    def logical_or(self, *args, **kwargs) -> Any: ...
    def logical_xor(self, *args, **kwargs) -> Any: ...
    def max(self, *args, **kwargs) -> Any: ...
    def max_mag(self, *args, **kwargs) -> Any: ...
    def min(self, *args, **kwargs) -> Any: ...
    def min_mag(self, *args, **kwargs) -> Any: ...
    def next_minus(self, *args, **kwargs) -> Any: ...
    def next_plus(self, *args, **kwargs) -> Any: ...
    def next_toward(self, *args, **kwargs) -> Any: ...
    def normalize(self, *args, **kwargs) -> Any: ...
    def number_class(self, *args, **kwargs) -> Any: ...
    def quantize(self, *args, **kwargs) -> Any: ...
    def radix(base) -> Any: ...
    def remainder_near(self, *args, **kwargs) -> Any: ...
    def rotate(self, *args, **kwargs) -> Any: ...
    def same_quantum(self, *args, **kwargs) -> Any: ...
    def scaleb(self, *args, **kwargs) -> Any: ...
    def shift(self, *args, **kwargs) -> Any: ...
    def sqrt(self, *args, **kwargs) -> Any: ...
    def to_eng_string(self, *args, **kwargs) -> Any: ...
    def to_integral() -> Any: ...
    def to_integral_exact(self, *args, **kwargs) -> Any: ...
    def to_integral_value(self, *args, **kwargs) -> Any: ...
    def __abs__(self) -> Any: ...
    def __add__(self, other) -> Any: ...
    def __bool__(self) -> Any: ...
    def __ceil__(self, *args, **kwargs) -> Any: ...
    def __complex__(self) -> Any: ...
    def __copy__(self) -> Any: ...
    def __deepcopy__(self) -> Any: ...
    def __divmod__(self, other) -> Any: ...
    def __eq__(self, other) -> Any: ...
    def __float__(self) -> Any: ...
    def __floor__(self, *args, **kwargs) -> Any: ...
    def __floordiv__(self, other) -> Any: ...
    def __format__(self, *args, **kwargs) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __hash__(self) -> Any: ...
    def __int__(self) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __mod__(self, other) -> Any: ...
    def __mul__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __neg__(self) -> Any: ...
    def __pos__(self) -> Any: ...
    def __pow__(self, other) -> Any: ...
    def __radd__(self, other) -> Any: ...
    def __rdivmod__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __rfloordiv__(self, other) -> Any: ...
    def __rmod__(self, other) -> Any: ...
    def __rmul__(self, other) -> Any: ...
    def __round__(self) -> Any: ...
    def __rpow__(self, other) -> Any: ...
    def __rsub__(self, other) -> Any: ...
    def __rtruediv__(self, other) -> Any: ...
    def __sizeof__(self) -> Any: ...
    def __sub__(self, other) -> Any: ...
    def __truediv__(self, other) -> Any: ...
    def __trunc__(self) -> Any: ...

class Enum:
    class _member_type_:
        __class__: ClassVar[getset_descriptor] = ...
        def __init__(self, *args, **kwargs) -> None: ...
        def __delattr__(self, name) -> Any: ...
        def __dir__(self) -> Any: ...
        def __eq__(self, other) -> Any: ...
        def __format__(self, *args, **kwargs) -> Any: ...
        def __ge__(self, other) -> Any: ...
        def __gt__(self, other) -> Any: ...
        def __hash__(self) -> Any: ...
        @classmethod
        def __init_subclass__(self, *args, **kwargs) -> Any: ...
        def __le__(self, other) -> Any: ...
        def __lt__(self, other) -> Any: ...
        def __ne__(self, other) -> Any: ...
        def __reduce__(self) -> Any: ...
        def __reduce_ex__(self, protocol) -> Any: ...
        def __setattr__(self, name, value) -> Any: ...
        def __sizeof__(self) -> Any: ...
        @classmethod
        def __subclasshook__(self, *args, **kwargs) -> Any: ...
    _generate_next_value_: ClassVar[function] = ...
    _member_map_: ClassVar[dict] = ...
    _member_names_: ClassVar[list] = ...
    _value2member_map_: ClassVar[dict] = ...
    __dir__: ClassVar[function] = ...
    __format__: ClassVar[function] = ...
    __hash__: ClassVar[function] = ...
    __reduce_ex__: ClassVar[function] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def _missing_(self, *args, **kwargs) -> Any: ...
    @property
    def name(self) -> Any: ...
    @property
    def value(self) -> Any: ...

class GeneratorType:
    gi_code: ClassVar[member_descriptor] = ...
    gi_frame: ClassVar[member_descriptor] = ...
    gi_running: ClassVar[member_descriptor] = ...
    gi_yieldfrom: ClassVar[getset_descriptor] = ...
    __name__: ClassVar[getset_descriptor] = ...
    __qualname__: ClassVar[getset_descriptor] = ...
    def close(self, *args, **kwargs) -> Any: ...
    def send(self, *args, **kwargs) -> Any: ...
    def throw(self, *args, **kwargs) -> Any: ...
    def __del__(self, *args, **kwargs) -> Any: ...
    def __iter__(self) -> Any: ...
    def __next__(self) -> Any: ...

class IPv4Address(ipaddress._BaseV4, ipaddress._BaseAddress):
    class _constants:
        _linklocal_network: ClassVar[ipaddress.IPv4Network] = ...
        _loopback_network: ClassVar[ipaddress.IPv4Network] = ...
        _multicast_network: ClassVar[ipaddress.IPv4Network] = ...
        _private_networks: ClassVar[list] = ...
        _public_network: ClassVar[ipaddress.IPv4Network] = ...
        _reserved_network: ClassVar[ipaddress.IPv4Network] = ...
        _unspecified_address: ClassVar[ipaddress.IPv4Address] = ...
    __init__: ClassVar[function] = ...
    _ip: ClassVar[member_descriptor] = ...
    __slots__: ClassVar[tuple] = ...
    @property
    def is_global(self) -> Any: ...
    @property
    def is_link_local(self) -> Any: ...
    @property
    def is_loopback(self) -> Any: ...
    @property
    def is_multicast(self) -> Any: ...
    @property
    def is_private(self) -> Any: ...
    @property
    def is_reserved(self) -> Any: ...
    @property
    def is_unspecified(self) -> Any: ...
    @property
    def packed(self) -> Any: ...

class IPv4Interface(ipaddress.IPv4Address):
    __init__: ClassVar[function] = ...
    __eq__: ClassVar[function] = ...
    __hash__: ClassVar[function] = ...
    __lt__: ClassVar[function] = ...
    __reduce__: ClassVar[function] = ...
    def hostmask(self, *args, **kwargs) -> Any: ...
    @property
    def ip(self) -> Any: ...
    @property
    def with_hostmask(self) -> Any: ...
    @property
    def with_netmask(self) -> Any: ...
    @property
    def with_prefixlen(self) -> Any: ...

class IPv4Network(ipaddress._BaseV4, ipaddress._BaseNetwork):
    class _address_class(ipaddress._BaseV4, ipaddress._BaseAddress):
        class _constants:
            _linklocal_network: ClassVar[ipaddress.IPv4Network] = ...
            _loopback_network: ClassVar[ipaddress.IPv4Network] = ...
            _multicast_network: ClassVar[ipaddress.IPv4Network] = ...
            _private_networks: ClassVar[list] = ...
            _public_network: ClassVar[ipaddress.IPv4Network] = ...
            _reserved_network: ClassVar[ipaddress.IPv4Network] = ...
            _unspecified_address: ClassVar[ipaddress.IPv4Address] = ...
        __init__: ClassVar[function] = ...
        _ip: ClassVar[member_descriptor] = ...
        __slots__: ClassVar[tuple] = ...
        @property
        def is_global(self) -> Any: ...
        @property
        def is_link_local(self) -> Any: ...
        @property
        def is_loopback(self) -> Any: ...
        @property
        def is_multicast(self) -> Any: ...
        @property
        def is_private(self) -> Any: ...
        @property
        def is_reserved(self) -> Any: ...
        @property
        def is_unspecified(self) -> Any: ...
        @property
        def packed(self) -> Any: ...
    __init__: ClassVar[function] = ...
    @property
    def is_global(self) -> Any: ...

class IPv6Address(ipaddress._BaseV6, ipaddress._BaseAddress):
    class _constants:
        _linklocal_network: ClassVar[ipaddress.IPv6Network] = ...
        _multicast_network: ClassVar[ipaddress.IPv6Network] = ...
        _private_networks: ClassVar[list] = ...
        _reserved_networks: ClassVar[list] = ...
        _sitelocal_network: ClassVar[ipaddress.IPv6Network] = ...
    __init__: ClassVar[function] = ...
    _ip: ClassVar[member_descriptor] = ...
    __slots__: ClassVar[tuple] = ...
    @property
    def ipv4_mapped(self) -> Any: ...
    @property
    def is_global(self) -> Any: ...
    @property
    def is_link_local(self) -> Any: ...
    @property
    def is_loopback(self) -> Any: ...
    @property
    def is_multicast(self) -> Any: ...
    @property
    def is_private(self) -> Any: ...
    @property
    def is_reserved(self) -> Any: ...
    @property
    def is_site_local(self) -> Any: ...
    @property
    def is_unspecified(self) -> Any: ...
    @property
    def packed(self) -> Any: ...
    @property
    def sixtofour(self) -> Any: ...
    @property
    def teredo(self) -> Any: ...

class IPv6Interface(ipaddress.IPv6Address):
    __init__: ClassVar[function] = ...
    __eq__: ClassVar[function] = ...
    __hash__: ClassVar[function] = ...
    __lt__: ClassVar[function] = ...
    __reduce__: ClassVar[function] = ...
    def hostmask(self, *args, **kwargs) -> Any: ...
    @property
    def ip(self) -> Any: ...
    @property
    def is_loopback(self) -> Any: ...
    @property
    def is_unspecified(self) -> Any: ...
    @property
    def with_hostmask(self) -> Any: ...
    @property
    def with_netmask(self) -> Any: ...
    @property
    def with_prefixlen(self) -> Any: ...

class IPv6Network(ipaddress._BaseV6, ipaddress._BaseNetwork):
    class _address_class(ipaddress._BaseV6, ipaddress._BaseAddress):
        class _constants:
            _linklocal_network: ClassVar[ipaddress.IPv6Network] = ...
            _multicast_network: ClassVar[ipaddress.IPv6Network] = ...
            _private_networks: ClassVar[list] = ...
            _reserved_networks: ClassVar[list] = ...
            _sitelocal_network: ClassVar[ipaddress.IPv6Network] = ...
        __init__: ClassVar[function] = ...
        _ip: ClassVar[member_descriptor] = ...
        __slots__: ClassVar[tuple] = ...
        @property
        def ipv4_mapped(self) -> Any: ...
        @property
        def is_global(self) -> Any: ...
        @property
        def is_link_local(self) -> Any: ...
        @property
        def is_loopback(self) -> Any: ...
        @property
        def is_multicast(self) -> Any: ...
        @property
        def is_private(self) -> Any: ...
        @property
        def is_reserved(self) -> Any: ...
        @property
        def is_site_local(self) -> Any: ...
        @property
        def is_unspecified(self) -> Any: ...
        @property
        def packed(self) -> Any: ...
        @property
        def sixtofour(self) -> Any: ...
        @property
        def teredo(self) -> Any: ...
    __init__: ClassVar[function] = ...
    hosts: ClassVar[function] = ...
    @property
    def is_site_local(self) -> Any: ...

class Path(pathlib.PurePath):
    _accessor: ClassVar[member_descriptor] = ...
    _closed: ClassVar[member_descriptor] = ...
    _init: ClassVar[function] = ...
    _make_child_relpath: ClassVar[function] = ...
    _opener: ClassVar[function] = ...
    _raise_closed: ClassVar[function] = ...
    _raw_open: ClassVar[function] = ...
    absolute: ClassVar[function] = ...
    chmod: ClassVar[function] = ...
    exists: ClassVar[function] = ...
    expanduser: ClassVar[function] = ...
    glob: ClassVar[function] = ...
    group: ClassVar[function] = ...
    is_block_device: ClassVar[function] = ...
    is_char_device: ClassVar[function] = ...
    is_dir: ClassVar[function] = ...
    is_fifo: ClassVar[function] = ...
    is_file: ClassVar[function] = ...
    is_mount: ClassVar[function] = ...
    is_socket: ClassVar[function] = ...
    is_symlink: ClassVar[function] = ...
    iterdir: ClassVar[function] = ...
    lchmod: ClassVar[function] = ...
    link_to: ClassVar[function] = ...
    lstat: ClassVar[function] = ...
    mkdir: ClassVar[function] = ...
    open: ClassVar[function] = ...
    owner: ClassVar[function] = ...
    read_bytes: ClassVar[function] = ...
    read_text: ClassVar[function] = ...
    rename: ClassVar[function] = ...
    replace: ClassVar[function] = ...
    resolve: ClassVar[function] = ...
    rglob: ClassVar[function] = ...
    rmdir: ClassVar[function] = ...
    samefile: ClassVar[function] = ...
    stat: ClassVar[function] = ...
    symlink_to: ClassVar[function] = ...
    touch: ClassVar[function] = ...
    unlink: ClassVar[function] = ...
    write_bytes: ClassVar[function] = ...
    write_text: ClassVar[function] = ...
    __enter__: ClassVar[function] = ...
    __exit__: ClassVar[function] = ...
    __slots__: ClassVar[tuple] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def cwd(self, *args, **kwargs) -> Any: ...
    @classmethod
    def home(self, *args, **kwargs) -> Any: ...

class Pattern:
    flags: ClassVar[member_descriptor] = ...
    groupindex: ClassVar[getset_descriptor] = ...
    groups: ClassVar[member_descriptor] = ...
    pattern: ClassVar[member_descriptor] = ...
    def findall(self, *args, **kwargs) -> Any: ...
    def finditer(self, *args, **kwargs) -> Any: ...
    def fullmatch(self, *args, **kwargs) -> Any: ...
    def match(self, *args, **kwargs) -> Any: ...
    def scanner(self, *args, **kwargs) -> Any: ...
    def search(self, *args, **kwargs) -> Any: ...
    def split(self, *args, **kwargs) -> Any: ...
    def sub(self, *args, **kwargs) -> Any: ...
    def subn(self, *args, **kwargs) -> Any: ...
    def __copy__(self) -> Any: ...
    def __deepcopy__(self) -> Any: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __hash__(self) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...

class SecretBytes:
    max_length: ClassVar[None] = ...
    min_length: ClassVar[None] = ...
    __hash__: ClassVar[None] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def display(self, *args, **kwargs) -> Any: ...
    def get_secret_value(self, *args, **kwargs) -> Any: ...
    @classmethod
    def validate(self, *args, **kwargs) -> Any: ...
    def __eq__(self, other) -> Any: ...
    @classmethod
    def __get_validators__(self, *args, **kwargs) -> Any: ...
    def __len__(self) -> Any: ...
    @classmethod
    def __modify_schema__(self, *args, **kwargs) -> Any: ...

class SecretStr:
    max_length: ClassVar[None] = ...
    min_length: ClassVar[None] = ...
    __hash__: ClassVar[None] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def display(self, *args, **kwargs) -> Any: ...
    def get_secret_value(self, *args, **kwargs) -> Any: ...
    @classmethod
    def validate(self, *args, **kwargs) -> Any: ...
    def __eq__(self, other) -> Any: ...
    @classmethod
    def __get_validators__(self, *args, **kwargs) -> Any: ...
    def __len__(self) -> Any: ...
    @classmethod
    def __modify_schema__(self, *args, **kwargs) -> Any: ...

class UUID:
    __init__: ClassVar[function] = ...
    int: ClassVar[member_descriptor] = ...
    is_safe: ClassVar[member_descriptor] = ...
    __eq__: ClassVar[function] = ...
    __ge__: ClassVar[function] = ...
    __getstate__: ClassVar[function] = ...
    __gt__: ClassVar[function] = ...
    __hash__: ClassVar[function] = ...
    __int__: ClassVar[function] = ...
    __le__: ClassVar[function] = ...
    __lt__: ClassVar[function] = ...
    __setattr__: ClassVar[function] = ...
    __setstate__: ClassVar[function] = ...
    __slots__: ClassVar[tuple] = ...
    @property
    def bytes(self) -> Any: ...
    @property
    def bytes_le(self) -> Any: ...
    @property
    def clock_seq(self) -> Any: ...
    @property
    def clock_seq_hi_variant(self) -> Any: ...
    @property
    def clock_seq_low(self) -> Any: ...
    @property
    def fields(self) -> Any: ...
    @property
    def hex(self) -> Any: ...
    @property
    def node(self) -> Any: ...
    @property
    def time(self) -> Any: ...
    @property
    def time_hi_version(self) -> Any: ...
    @property
    def time_low(self) -> Any: ...
    @property
    def time_mid(self) -> Any: ...
    @property
    def urn(self) -> Any: ...
    @property
    def variant(self) -> Any: ...
    @property
    def version(self) -> Any: ...

class deque:
    maxlen: ClassVar[getset_descriptor] = ...
    __hash__: ClassVar[None] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def append(self, *args, **kwargs) -> Any: ...
    def appendleft(self, *args, **kwargs) -> Any: ...
    def clear(self, *args, **kwargs) -> Any: ...
    def copy(self, *args, **kwargs) -> Any: ...
    def count(self, *args, **kwargs) -> Any: ...
    def extend(self, *args, **kwargs) -> Any: ...
    def extendleft(self, *args, **kwargs) -> Any: ...
    def index(self, *args, **kwargs) -> Any: ...
    def insert(index, object) -> Any: ...
    def pop(self, *args, **kwargs) -> Any: ...
    def popleft(self, *args, **kwargs) -> Any: ...
    def remove(value) -> Any: ...
    def reverse() -> Any: ...
    def rotate(self, *args, **kwargs) -> Any: ...
    def __add__(self, other) -> Any: ...
    def __bool__(self) -> Any: ...
    def __contains__(self, other) -> Any: ...
    def __copy__(self) -> Any: ...
    def __delitem__(self, other) -> Any: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __getitem__(self, index) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __iadd__(self, other) -> Any: ...
    def __imul__(self, other) -> Any: ...
    def __iter__(self) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __len__(self) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __mul__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __reversed__() -> Any: ...
    def __rmul__(self, other) -> Any: ...
    def __setitem__(self, index, object) -> Any: ...
    def __sizeof__() -> Any: ...
