from ...engine.result import FilterResult as FilterResult, FrozenResult as FrozenResult, MergedResult as MergedResult
from ...util.concurrency import greenlet_spawn as greenlet_spawn
from typing import Any, Optional

class AsyncCommon(FilterResult):
    async def close(self) -> None: ...

class AsyncResult(AsyncCommon):
    def __init__(self, real_result: Any) -> None: ...
    def keys(self): ...
    def unique(self, strategy: Optional[Any] = ...): ...
    def columns(self, *col_expressions: Any): ...
    async def partitions(self, size: Optional[Any] = ...) -> None: ...
    async def fetchone(self): ...
    async def fetchmany(self, size: Optional[Any] = ...): ...
    async def all(self): ...
    def __aiter__(self): ...
    async def __anext__(self): ...
    async def first(self): ...
    async def one_or_none(self): ...
    async def scalar_one(self): ...
    async def scalar_one_or_none(self): ...
    async def one(self): ...
    async def scalar(self): ...
    async def freeze(self): ...
    def merge(self, *others: Any): ...
    def scalars(self, index: int = ...): ...
    def mappings(self): ...

class AsyncScalarResult(AsyncCommon):
    def __init__(self, real_result: Any, index: Any) -> None: ...
    def unique(self, strategy: Optional[Any] = ...): ...
    async def partitions(self, size: Optional[Any] = ...) -> None: ...
    async def fetchall(self): ...
    async def fetchmany(self, size: Optional[Any] = ...): ...
    async def all(self): ...
    def __aiter__(self): ...
    async def __anext__(self): ...
    async def first(self): ...
    async def one_or_none(self): ...
    async def one(self): ...

class AsyncMappingResult(AsyncCommon):
    def __init__(self, result: Any) -> None: ...
    def keys(self): ...
    def unique(self, strategy: Optional[Any] = ...): ...
    def columns(self, *col_expressions: Any): ...
    async def partitions(self, size: Optional[Any] = ...) -> None: ...
    async def fetchall(self): ...
    async def fetchone(self): ...
    async def fetchmany(self, size: Optional[Any] = ...): ...
    async def all(self): ...
    def __aiter__(self): ...
    async def __anext__(self): ...
    async def first(self): ...
    async def one_or_none(self): ...
    async def one(self): ...
