from . import roles as roles, visitors as visitors
from .. import exc as exc, util as util
from ..util import HasMemoized as HasMemoized, hybridmethod as hybridmethod
from .traversals import HasCacheKey as HasCacheKey, HasCopyInternals as HasCopyInternals, MemoizedHasCacheKey as MemoizedHasCacheKey
from .visitors import ClauseVisitor as ClauseVisitor, ExtendedInternalTraversal as ExtendedInternalTraversal, InternalTraversal as InternalTraversal
from typing import Any, Optional

coercions: Any
elements: Any
type_api: Any
PARSE_AUTOCOMMIT: Any
NO_ARG: Any

class Immutable:
    def unique_params(self, *optionaldict: Any, **kwargs: Any) -> None: ...
    def params(self, *optionaldict: Any, **kwargs: Any) -> None: ...

class SingletonConstant(Immutable):
    def __new__(cls, *arg: Any, **kw: Any): ...

class _DialectArgView(util.collections_abc.MutableMapping):
    obj: Any = ...
    def __init__(self, obj: Any) -> None: ...
    def __getitem__(self, key: Any): ...
    def __setitem__(self, key: Any, value: Any) -> None: ...
    def __delitem__(self, key: Any) -> None: ...
    def __len__(self): ...
    def __iter__(self) -> Any: ...

class _DialectArgDict(util.collections_abc.MutableMapping):
    def __init__(self) -> None: ...
    def __len__(self): ...
    def __iter__(self) -> Any: ...
    def __getitem__(self, key: Any): ...
    def __setitem__(self, key: Any, value: Any) -> None: ...
    def __delitem__(self, key: Any) -> None: ...

class DialectKWArgs:
    @classmethod
    def argument_for(cls, dialect_name: Any, argument_name: Any, default: Any) -> None: ...
    def dialect_kwargs(self): ...
    @property
    def kwargs(self): ...
    def dialect_options(self): ...

class CompileState:
    plugins: Any = ...
    @classmethod
    def create_for_statement(cls, statement: Any, compiler: Any, **kw: Any): ...
    statement: Any = ...
    def __init__(self, statement: Any, compiler: Any, **kw: Any) -> None: ...
    @classmethod
    def get_plugin_class(cls, statement: Any): ...
    @classmethod
    def plugin_for(cls, plugin_name: Any, visit_name: Any): ...

class Generative(HasMemoized): ...
class InPlaceGenerative(HasMemoized): ...
class HasCompileState(Generative): ...

class _MetaOptions(type):
    def __init__(cls, classname: Any, bases: Any, dict_: Any) -> None: ...
    def __add__(self, other: Any): ...

class Options:
    def __init__(self, **kw: Any) -> None: ...
    def __add__(self, other: Any): ...
    def __eq__(self, other: Any) -> Any: ...
    @classmethod
    def isinstance(cls, klass: Any): ...
    def add_to_element(self, name: Any, value: Any): ...
    @classmethod
    def safe_merge(cls, other: Any): ...
    @classmethod
    def from_execution_options(cls, key: Any, attrs: Any, exec_options: Any, statement_exec_options: Any): ...

class CacheableOptions(Options, HasCacheKey): ...

class ExecutableOption(HasCopyInternals, HasCacheKey):
    __visit_name__: str = ...

class Executable(roles.StatementRole, Generative):
    supports_execution: bool = ...
    is_select: bool = ...
    is_update: bool = ...
    is_insert: bool = ...
    is_text: bool = ...
    is_delete: bool = ...
    is_dml: bool = ...
    def options(self, *options: Any) -> None: ...
    def execution_options(self, **kw: Any) -> None: ...
    def get_execution_options(self): ...
    def execute(self, *multiparams: Any, **params: Any): ...
    def scalar(self, *multiparams: Any, **params: Any): ...
    @property
    def bind(self): ...

class prefix_anon_map(dict):
    def __missing__(self, key: Any): ...

class SchemaEventTarget: ...

class SchemaVisitor(ClauseVisitor):
    __traverse_options__: Any = ...

class ColumnCollection:
    def __init__(self, columns: Optional[Any] = ...) -> None: ...
    def keys(self): ...
    def values(self): ...
    def items(self): ...
    def __bool__(self): ...
    def __len__(self): ...
    def __iter__(self) -> Any: ...
    def __getitem__(self, key: Any): ...
    def __getattr__(self, key: Any): ...
    def __contains__(self, key: Any): ...
    def compare(self, other: Any): ...
    def __eq__(self, other: Any) -> Any: ...
    def get(self, key: Any, default: Optional[Any] = ...): ...
    def __setitem__(self, key: Any, value: Any) -> None: ...
    def __delitem__(self, key: Any) -> None: ...
    def __setattr__(self, key: Any, obj: Any) -> None: ...
    def clear(self) -> None: ...
    def remove(self, column: Any) -> None: ...
    def update(self, iter_: Any) -> None: ...
    __hash__: Any = ...
    def add(self, column: Any, key: Optional[Any] = ...) -> None: ...
    def contains_column(self, col: Any): ...
    def as_immutable(self): ...
    def corresponding_column(self, column: Any, require_embedded: bool = ...): ...

class DedupeColumnCollection(ColumnCollection):
    def add(self, column: Any, key: Optional[Any] = ...) -> None: ...
    def extend(self, iter_: Any) -> None: ...
    def remove(self, column: Any) -> None: ...
    def replace(self, column: Any) -> None: ...

class ImmutableColumnCollection(util.ImmutableContainer, ColumnCollection):
    def __init__(self, collection: Any) -> None: ...
    add: Any = ...
    extend: Any = ...
    remove: Any = ...

class ColumnSet(util.ordered_column_set):
    def contains_column(self, col: Any): ...
    def extend(self, cols: Any) -> None: ...
    def __add__(self, other: Any): ...
    def __eq__(self, other: Any) -> Any: ...
    def __hash__(self) -> Any: ...
